﻿-- pgCon2014 PostgreSQL Working with Network Data
-- James Hanson 21-May-14
-- Dragon Research Group HTTP malicious IP
-- Downloaded from http://www.dragonresearchgroup.org/insight/sshpwauth.txt, vncprobe.txt and http-report.txt

-- But http-report, vncprobe and sshpwauth have the same structure
CREATE OR REPLACE VIEW v_ip_probes AS (
  SELECT 
    'http_report' AS source,
    asn,
    asname,
    netblock,
    utc_time,
    category
  FROM http_report
  UNION ALL
  SELECT 
    'vncprobe' AS source,
    asn,
    asname,
    netblock,
    utc_time,
    category
  FROM vncprobe
  UNION ALL 
  SELECT
    'sshpwauth' AS source,
    asn,
    asname,
    netblock,
    utc_time,
    category
  FROM sshpwauth
);

-- DROP VIEW v_ip_probes;
-- SELECT * FROM v_ip_probes LIMIT 100;
-- SELECT to_char(count(*), '999G999') AS num_recs FROM v_ip_probes;

-- Take a look at this subtle difference between the sources
SELECT * FROM v_ip_probes WHERE source = 'sshpwauth' LIMIT 100;  -- no subnet in the netblock column
SELECT * FROM v_ip_probes WHERE source = 'vncprobe' LIMIT 100;   -- no subnet in the netblock column
SELECT * FROM v_ip_probes WHERE source = 'http_report' LIMIT 100;   -- a subnet in the netblock column
-- NOTE:  You can still use the inet operators on the view.  PostgreSQL overloads the functions / operators
