﻿-- pgCon2014 PostgreSQL Working with Network data
-- James Hanson 21-May-14
-- National Vulnerabilities Database - xsd version 1.2
-- Downloaded from http://nvd.nist.gov/download/nvdcve-2014.xml
-- Contains the current list of CVEs (Common Vulnerability Exposures) and resulting
--    IAVAs (Information Assurance Vulnerabiliity Alert)s

-- NOTE:  I removed the xmlns (XML Name Space) entries in the first <nvd ...> tag to make this simpler.
-- See http://stackoverflow.com/questions/17799790/using-xpath-to-extract-data-from-an-xml-column-in-postgres for details

CREATE TABLE nvd_12b (
  id SERIAL,
  xml_col XML);

-- pg_read_binary_file is limited to "Only files within the database cluster directory and the log_directory"
-- mkdir /opt/PostgreSQL/9.3/data/Pgcon14
-- cp /Pgcon14/Scripts/050_NVD/nvdcve-2014b.xml /opt/PostgreSQL/9.3/data/Pgcon14/nvdcve-2014b.xml

INSERT INTO nvd_12b (xml_col) VALUES (
  XMLPARSE(DOCUMENT convert_from(
    pg_read_binary_file('/opt/PostgreSQL/9.3/data/Pgcon14/nvdcve-2014b.xml'), 'UTF8'))
  );

COMMENT ON TABLE nvd_12b IS 'Downloaded from http://nvd.nist.gov/download/nvdcve-2014.xml'; 

-- TRUNCATE TABLE nvd_12b;
-- DROP TABLE nvd_12b;
-- SELECT * FROM nvd_12b LIMIT 100;

-- Verify that we loaded a valid XML document
SELECT
  xml_col IS DOCUMENT AS is_document  -- IS DOCUMENT is a PostgreSQL operator that returns T/F
FROM nvd_12b;
