﻿-- pgCon2014 Working with Network Data
-- James Hanson 21-May-14
-- Set postgresql configuration

SELECT 
  name,
  setting,
  unit, 
  category,
  short_desc
FROM pg_settings
WHERE name IN (
  'archive_mode',	-- leave off
  'config_file',	-- checking to make sure ...
  'effective_cache_size', -- from (16,284 * 8kB = 130,272MB) to 3/4 RAM.  (3GB RAM * 3/4 ~= 2GB RAM, or 262,144 8kB blocks)
  'fsync',		-- from on to off off (be careful of this in production!)
  'maintenance_work_mem', -- from 16,384KB to 512M
  'max_connections',	-- from 100 to 10
  'shared_buffers',	-- from (16,284 * 8kB = 130,272MB) to 1/4 RAM (3GB * 1/4 ~= 768MB, or 98,304 8kB blocks)
  'synchronous_commit',	-- from on to off
  'temp_buffers',	-- from (1,024 * 8kB = 8kB) to 1GB
  'work_mem'		-- from 1kB to 1GB
)
ORDER BY name;