#!/usr/bin/python

# pgCon2014 PostgreSQL and Network Data workshop
# James Hanson 21-May-14
# tracert files 
# downloaded from ftp://ita.ee.lbl.gov/traces/npd-routes-2.tar.gz
# Process:
#     1. downloadand unzip the npd-routes-2.tar.gz filefrom above
#     2. create the list of file paths using:
#         # find `pwd` -type f > listOfTracertFiles.txt
#     3. removed /Pgcon14/Scripts/090_tracert/Tracert/xprobes/xprobes.2/j1 
#            and /Pgcon14/Scripts/090_tracert/Tracert/xprobes/xprobes.2/j2
#            and /Pgcon14/Scripts/090_tracert/Tracert/xprobes/xprobes.2/j3
#            and /Pgcon14/Scripts/090_tracert/Tracert/xprobes/xprobes.2/j4
#     4. run this python script to genertate tracert.csv
#     5. import tracert.csv with the script tracert_DDL.sql

from os.path import basename

file_num = 1
# open files
f = open('listOfTracertFiles.txt', 'r')
# f = open('listOfTestFiles.txt', 'r')
g = open('tracert.csv', 'w')

def writeFormattedTracert(file_name):
    with open(file_name) as h:
        tracefile = h.readlines()
        
        #dissect the first line
        lparen = tracefile[0].find('(')
        rparen = tracefile[0].find(')')

        to_dns = tracefile[0][14:(lparen - 1)]
        to_ip = tracefile[0][lparen + 1:rparen]

        line_start = basename(file_name) + '\t' + to_dns + '\t' + to_ip

        # dissect the lines containing the traces
        for i in range(2, len(tracefile)):

            if i == 2:
                sip = ''

            # *'s represent packets that are not acknowledged in the expected tim
            # 3 *'s indicate there is no dip 
            count_splat = tracefile[i].count('*')  
            if count_splat == 0:
                hop = tracefile[i][:2].lstrip()
                dip = tracefile[i][4:tracefile[i].find(' ', 10)]
            elif count_splat == 1:
                repline = tracefile[i].replace('* ', '')
                hop = tracefile[i][:2].lstrip()
                dip = repline[4:repline.find(' ', 10)]
            elif count_splat == 2:
                repline = tracefile[i].replace('* ', '')
                hop = tracefile[i][:2].lstrip()
                dip = repline[4:repline.find(' ', 10)]
            else:
                sip = ''
                continue 

            line_end = hop + '\t' + sip  + '\t' + dip

            line = line_start + '\t' + line_end + '\n'
            g.write(line)

            sip = dip

for line in iter(f):
    writeFormattedTracert(line.rstrip())
    print(file_num)
    file_num += 1

f.close()
g.close()
